{ This is a Bug test.
  First I tried calling  WindowFromPoint(pppt)  a standard function of windows.
  This makes that the pascal  Str  function doesn't work.
  Then simplifying, I arrive at this program, showing that
  WindowFromPoint(pppt)  makes the writeln function having problems.

  This is a solution of the bug problem :
  instead of defining
  function WindowFromPoint(Point:POINT):HWND; external 'user32' name 'WindowFromPoint';
  as it is done in the ...\freepascal\source\rtl\win32\wininc\func.inc
  define it as bellow :
  function MyWindowFromPoint(nXPoint,nYPoint:longint):integer; external 'user32' name 'WindowFromPoint';

  Then it works.
  To have the standard call, you must define first  MyWindowFromPoint,
  then using it you can define  WindowFromPoint  as done bellow
-------------------------------------------------------}
program tEx062b;

//uses windows;

type
  HWND   = integer;
  PPoint = ^TPoint;
  TPoint = record
    x,y : longint;
    end;
var
  pppT : TPoint;
  hhh : integer;
  notused : integer;

function MyGetCursorPos(lpPoint:PPOINT):longbool; external 'user32' name 'GetCursorPos';
function MyWindowFromPoint(nXPoint,nYPoint:longint):integer; external 'user32' name 'WindowFromPoint';

function WindowFromPoint(Point:TPOINT):HWND;
//==========================================
begin
WindowFromPoint:=MyWindowFromPoint(Point.x, Point.y);

// I tested that the previous call is correct, and not this one.
// WindowFromPoint:=MyWindowFromPoint(Point.y,Point.x);
end;  // WindowFromPoint

begin // MAIN
repeat
   write('Put the mouse cursor over a window and hit Return (Ctrl-C to stop)');
   readln;

   MyGetCursorPos(@pppT);
   hhh:=WindowFromPoint(pppT);

   writeln('Window handle=', hhh);  // I get an error 103 here.
   writeln;
   until FALSE;
end.
